#include "BasicBlock.h"
#include "Quadruple.h"
#include "../Compiler.h"

void BasicBlock::finishQuads() {
	if (!afterInit.empty()) {
		while (!quads.empty() && quads.back()->isFinal()) {
			auto final = quads.back();
			quads.pop_back();
			afterInit.emplace_back(final);
		}

		for (const auto& q : afterInit) {
			assert(q->block.get() == this);
			quads.push_back(q);
		}
		afterInit.clear();
	}

	auto self = this->shared_from_this();
	for (const auto& q : quads) {
		q->useVariables();
	}
}

const map<VariablePtr, VariablePtr>& BasicBlock::getPhiMapping(const BasicBlockPtr &b) const {
	assert(phi);
	for (uint i = 0; i < in.size(); i++) {
		if (in[i] == b) {
			return phi->phi[i];
		}
	}
	throw runtime_error("BasicBlock::getPhiMapping: In block not found");
}