#!/bin/bash
t=0
RED='\033[0;31m'
GREEN='\033[0;32m'
NONE='\033[0m'
BIN="./latc_x86"
function red {
	echo -e "${RED}$@${NONE}"
}
function green {
	echo -e "${GREEN}$@${NONE}"
}
VALGRIND=""

make -j8 && for i in lat/lattests/good/*.lat; do
	t=$((t+1))
	($BIN "$i" &>/dev/null);
	if ! [ $? -eq 0 ]; then
		red "FAIL $i";
		$BIN "$i"
		exit 1;
	fi
	if [ -f "${i%.*}.input" ]; then
		inp="${i%.*}.input"
	else
		inp=/dev/null
	fi

	if ! diff <( $VALGRIND timeout 2 ${i%.*} < "$inp" ) "${i%.*}.output"; then
		red "ERROR $i"
		exit 1
	fi
done && green good OK && for ext in `ls tests/good/`; do
	ok=1
	for i in tests/good/$ext/*.lat; do
		($BIN "$i" &>/dev/null);
		if ! [ $? -eq 0 ]; then
			red "$ext fails on $i";
			$BIN "$i"
			ok=0;
			break;
		fi

		if [ -f "${i%.*}.input" ]; then
			inp="${i%.*}.input"
		else
			inp=/dev/null
		fi

		if ! diff <( $VALGRIND timeout 2 ${i%.*} < "$inp" ) "${i%.*}.output"; then
			red "ERROR $i"
			ok=0;
		fi
	done
	if [ $ok -eq 1 ]; then
		green "OK: $ext passed!"
	fi
done && for i in lat/lattests/bad/*.lat; do
	t=$((t+1))
	($BIN "$i" &>/dev/null);
	if [ $? -eq 0 ]; then
		red "FAIL $i";
		$BIN "$i"
		exit 1;
	fi
done && green "OK: $t bad tests passed!" && for i in tests/bad/semantic/*.lat; do
	t=$((t+1))
	($BIN "$i" &>/dev/null);
	if [ $? -eq 0 ]; then
		red "FAIL $i";
		$BIN "$i"
		exit 1;
	fi
done && green "OK: $t bad+ tests passed!" && for ext in `ls lat/lattests/extensions`; do
	ok=1
	for i in lat/lattests/extensions/$ext/*.lat; do
		($BIN "$i" &>/dev/null);
		if ! [ $? -eq 0 ]; then
			red "$ext fails on $i";
			$BIN "$i"
			ok=0;
			break;
		fi


		if ! diff <( $VALGRIND timeout 2 ${i%.*} < "$inp" ) "${i%.*}.output"; then
			red "ERROR $i"
			exit 1
		fi
	done
	if [ $ok -eq 1 ]; then
		green "OK: $ext passed!"
	fi
done && for ext in `ls tests/extensions`; do
	ok=1
	for i in lat/lattests/extensions/$ext/*.lat; do
		($BIN "$i" &>/dev/null);
		if ! [ $? -eq 0 ]; then
			red "$ext fails on $i";
			$BIN "$i"
			ok=0;
			break;
		fi

		if [ -f "${i%.*}.input" ]; then
			inp="${i%.*}.input"
		else
			inp=/dev/null
		fi


		if ! diff <( $VALGRIND timeout 2 ${i%.*} < "$inp" ) "${i%.*}.output"; then
			red "ERROR $i"
			exit 1
		fi
	done
	if [ $ok -eq 1 ]; then
		green "OK: $ext passed!"
	fi
done